from tkinter import *
import math, time,random
NLEARN  = 50000 # 学習繰り返し回数
NSAMPLE = 10     # 訓練データサンプル数
NINPUT  = 35     # 入力ノード数
NHIDDEN = 45     # 中間層（隠れ層）の素子数
NOUTPUT = 10     # 出力素子数
EPS     = 1     # 学習時重み修正の程度（学習速度）
ENDERR  = 0.002 # プログラム停止の学習誤差
NLAYH   = 2     # 隠れ層の数
def array(N1, N2=0,N3=0):#■配列宣言
    if N2==0: return [0 for i in range(N1)]
    if N3==0: return [[0 for i in range(N2)]
                      for j in range(N1)]
    return[[[0 for i in range(N3)]for j in range(N2)]
           for j in range(N1)]
#■トレーニング用データ

tx=[[0,1,1,0,0, 1,0,0,1,0, 1,0,0,1,0, 1,0,0,1,0, 1,0,0,1,0, 1,0,0,1,0, 0,1,1,0,0],#0
    [0,0,1,0,0, 0,1,1,0,0, 0,0,1,0,0, 0,0,1,0,0, 0,0,1,0,0, 0,0,1,0,0, 0,1,1,1,0],#1
    [0,1,1,1,0, 1,0,0,0,1, 0,0,0,0,1, 0,0,0,1,0, 0,0,1,0,0, 0,1,0,0,0, 1,1,1,1,1],#2
    [0,1,1,1,0, 1,0,0,0,1, 0,0,0,0,1, 0,1,1,1,0, 0,0,0,0,1, 1,0,0,0,1, 0,1,1,1,0],#3
    [0,0,0,1,0, 0,0,1,1,0, 0,1,0,1,0, 1,0,0,1,0, 1,1,1,1,1, 0,0,0,1,0, 0,0,0,1,0],#4
    [1,1,1,1,1, 1,0,0,0,0, 1,0,0,0,0, 1,1,1,1,0, 0,0,0,0,1, 1,0,0,0,1, 0,1,1,1,0],#5
    [0,1,1,1,0, 1,0,0,0,1, 1,0,0,0,0, 1,1,1,1,0, 1,0,0,0,1, 1,0,0,0,1, 0,1,1,1,0],#6
    [1,1,1,1,1, 1,0,0,0,1, 0,0,0,1,0, 0,0,0,1,0, 0,0,1,0,0, 0,0,1,0,0, 0,0,1,0,0],#7
    [0,1,1,1,0, 1,0,0,0,1, 1,0,0,0,1, 0,1,1,1,0, 1,0,0,0,1, 1,0,0,0,1, 0,1,1,1,0],#8
    [0,1,1,1,0, 1,0,0,0,1, 1,0,0,0,1, 0,1,1,1,1, 0,0,0,0,1, 1,0,0,0,1, 0,1,1,1,0]]#9
#    0 1 2 3 4 5 6 7 8 9   0 1 2 3 4 5 6 7 8 9   0 1 2 3 4 5 6 7 8 9
ty=[[1,0,0,0,0,0,0,0,0,0],[0,1,0,0,0,0,0,0,0,0],[0,0,1,0,0,0,0,0,0,0],
    [0,0,0,1,0,0,0,0,0,0],[0,0,0,0,1,0,0,0,0,0],[0,0,0,0,0,1,0,0,0,0],
    [0,0,0,0,0,0,1,0,0,0],[0,0,0,0,0,0,0,1,0,0],[0,0,0,0,0,0,0,0,1,0],
    [0,0,0,0,0,0,0,0,0,1]]
#■データ領域(入力層・隠れ層は閾値学習用を1個余分に用意)
x=array(NINPUT+1); h=array(NLAYH,NHIDDEN+1); y=array(NOUTPUT)
Win=array(NINPUT+1, NHIDDEN+1) #入力層の重み(接続荷重)
Wh=array(NLAYH,NHIDDEN+1,NHIDDEN+1)#隠れ層の重み(接続荷重)
Wout=array(NHIDDEN+1, NOUTPUT+1)#出力層の重み(接続荷重)
y_back=array(NOUTPUT+1)#出力層からの逆伝播量
w_back=array(NHIDDEN+1)#隠れ層からの逆伝播量
h_back=array(NHIDDEN+1)#隠れ層からの逆伝播量
sigmoidTB=array(100)   #高速化のためのシグモイド関数表
#-----------------------------------------------------
def initialize():      #■初期化
    for i in range(100):#シグモイド関数表
        sigmoidTB[i]=1.0/(1.0+math.exp(-0.2*float(i-50)))
    for i in range(NINPUT+1):
        for j in range(NHIDDEN+1):
            Win[i][j]=(random.random()-0.5)*2
    for i in range(NHIDDEN+1):
        for j in range(NOUTPUT+1):
            Wout[i][j]=(random.random()-0.5)*2
    for k in range(len(Wh)):
        for i in range(NHIDDEN+1):
            for j in range(NHIDDEN+1):
                Wh[k][i][j]=(random.random()-0.5)*2
def sigmoid(inDT):     #■シグモイド関数表索引
    ID=int(inDT*5+50)
    if ID>=99: return sigmoidTB[99]
    if ID<= 0: return sigmoidTB[0]
    return sigmoidTB[ID]
#def sigmoid(inDT):     #■シグモイド関数表索引
#    return (1+math.tanh(inDT))*0.5

def proceed(isample):  #■順伝播処理
    for i in range(NINPUT): #入力値を1層目に移す
        x[i]=float(tx[isample][i])
    x[NINPUT]=1.0           # 閾値学習用
    for j in range(NHIDDEN+1):# 入力素子値の計算
        net=0.0
        for i in range(NINPUT+1):net+=Win[i][j]*x[i]
        h[0][j]=sigmoid(net)   # シグモイド関数の適用
    for k in range(1,NLAYH):
        for j in range(NHIDDEN+1):# 隠れ素子値の計算
            net=0.0
            for i in range(NHIDDEN+1):net+=Wh[k-1][i][j]*h[k-1][i]
            h[k][j]=sigmoid(net)   # シグモイド関数の適用
    NL=NLAYH-1
    for j in range(NOUTPUT):# 出力素子値の計算
        net=0.0
        for i in range(NHIDDEN+1):net+=Wout[i][j]*h[NL][i]
        y[j]=sigmoid(net)   # シグモイド関数の適用
def evalError(isample):#■誤差評価
    error=0
    for j in range(NOUTPUT):
        df=ty[j][isample]-y[j]; error+=df*df
    return error/float(NOUTPUT)
def backProp(isample): #■逆伝播処理
    for j in range(NOUTPUT):  # 出力誤差を逆伝播初期値とする
        y_back[j]=(y[j]-ty[j][isample])*(1-y[j])*y[j]
    NL=NLAYH-1
    for i in range(NHIDDEN+1):  # 隠れ層への逆伝播計算
        net=0.0
        for j in range(NOUTPUT):net+=Wout[i][j]*y_back[j]
        h_back[i]=net*(1.0-h[NL][i])*h[NL][i]
    for i in range(NHIDDEN+1):# 出力層の重み変更
        for j in range(NOUTPUT+1):
            Wout[i][j]-=EPS*h[NL][i]*y_back[j]
    for k in range(NL-1,-1,-1):# 隠れ層への逆伝播計算
        for i in range(NHIDDEN+1):
            net=0.0
            for j in range(NHIDDEN+1):
                net+=Wh[k][i][j]*h_back[j]
            w_back[i]=net*(1.0-h[k][i])*h[k][i]
        for i in range(NHIDDEN+1):# 隠れ層の重み変更
            for j in range(NOUTPUT+1):
                Wh[k][i][j]-=EPS*h[k][i]*h_back[j]
        for i in range(len(h_back)):h_back[i]=w_back[i]
    for i in range(NINPUT+1): # 入力層の重み変更
        for j in range(NHIDDEN+1):Win[i][j]-=EPS*x[i]*h_back[j]
def dsp(canvas,i,error,N,merror,endErr):#■訓練結果表示
    canvas.delete("DT")
    font=('Times',10);font2=('Times',8)
    canvas.create_text(200,10,
                      text=("学習回数 %5d  誤差評価値 "+
                            "%12.4E < %12.4E")%(i,merror, endErr),
                      fill="blue",font=font,tag="DT")
    DX=math.log(10)*25;XX=200
    for i in range(4):        #対数目盛
        canvas.create_text(XX,30,text="10",fill="black",
                           font=font,tag="DT")
        canvas.create_text(XX+10,25,text="%d"%(i-4),
                           fill="black",font=font2,tag="DT")
        XX+=DX
        for j in range(1,10):
            x=200+math.log(math.pow(10,i)*float(j))*25
            canvas.create_line(x,40,x,40*N*20,fill="blue",
                               width=1,tag="DT")
    x=200+math.log(endErr*10E3)*25
    canvas.create_line(x,40,x,40*N*20,fill="darkred",
                       width=1,tag="DT")
    canvas.create_text(XX,30,text="10",fill="black",
                       font=font,tag="DT")
    canvas.create_text(XX+10,25,text="0",fill="black",
                       font=font2,tag="DT")
    for j in range(N):#訓練データのグラフ
        canvas.create_text(100,j*20+50,
                           text="訓練データ No. %2d : (%12.4E)"
                           %(j+1,error[j]),
                           fill="black",font=font2,tag="DT")
        Y=50+j*20
        canvas.create_line(200,Y,200+math.log(error[j]*10E3)*25,
                           Y,fill="red",width=5,tag="DT")
    root.update()
    time.sleep(0.0001)
def printSample(k):#入力サンプルのパターン表示
    for i in range(7):
        CH=""
        for j in range(5):
            ij=i*5+j; dt=tx[k][ij]
            if dt==0:CH+="□"
            else: CH+="■"
        print(CH)
#■メイン処理
dspLearn=True
if dspLearn:
    root=Tk();root.title("逆伝播法")
    canvas=Canvas(root,width=500,height=300)
    canvas.pack();root.update()
ERR=array(NSAMPLE);initialize()
for i in range(NLEARN):#学習回数分繰り返し
    merror=0
    for j in range(NSAMPLE):#各サンプル別の学習
        proceed(j)          #　前進処理
        ERR[j]=evalError(j) #  誤差評価
        if ERR[j]>merror:merror=ERR[j]
        backProp(j)         #  逆伝播
    if dspLearn:dsp(canvas,i,ERR,NSAMPLE,merror,ENDERR)
    if merror<ENDERR:break
print("\n収れん回数",i)
for j in range(NSAMPLE):
    proceed(j)
    print("\nSample No.=",j);printSample(j)
    print("\n出力,訓練データ, 出力 ,  階段関数での評価")
    print("-----------------------------------------")
    for k in range(NOUTPUT):
        print("  y%d,%5d, %10.4f, %5d" %(k,ty[k][j],y[k],int(y[k]+0.5)))
if dspLearn:root.mainloop()
        

        
        
